#include "JsonConverter.h"

#include <ArmarXCore/core/logging/Logging.h>

#include <RobotAPI/libraries/aron/converter/json/NLohmannJSONConverter.h>

namespace armarx::armem::server::ltm::processor::converter::data::object
{
    JsonConverter::ConversionResult
    JsonConverter::_convert(const aron::data::DictPtr& data)
    {
        nlohmann::json j =
            aron::data::converter::AronNlohmannJSONConverter::ConvertToNlohmannJSON(data);
        auto str = j.dump(2);
        return {std::vector<unsigned char>(str.begin(), str.end()), ""};
    }

    aron::data::DictPtr
    JsonConverter::_convert(const ConversionResult& data, const armarx::aron::Path& p)
    {
        std::string str(data.data.begin(), data.data.end());
        nlohmann::json j = nlohmann::json::parse(str);
        return aron::data::converter::AronNlohmannJSONConverter::ConvertFromNlohmannJSONObject(j,
                                                                                               p);
    }
} // namespace armarx::armem::server::ltm::processor::converter::data::object
