#pragma once

#include <map>
#include <string>

#include <Eigen/Core>

#include <RobotAPI/libraries/armem_robot_state/aron/Exteroception.aron.generated.h>

#include "ConverterInterface.h"


namespace armarx::armem::server::robot_state::exteroception
{
    struct ConverterValue;
    // class ConverterTools;


    class ArmarDEConverter : public ConverterInterface
    {
    public:
        ArmarDEConverter();
        ~ArmarDEConverter() override;


        aron::data::DictPtr
        convert(const RobotUnitDataStreaming::TimeStep& data,
                const RobotUnitDataStreaming::DataStreamingDescription& description) override;


    protected:
        void process(arondto::Exteroception& dtoExteroception,
                     const std::string& entryName,
                     const ConverterValue& value);


    private:
        

        void processToFEntry(std::map<std::string, armarx::armem::exteroception::arondto::ToF>& fts,
                             const std::vector<std::string>& split,
                             const ConverterValue& value);

        void processToFEntry(armarx::armem::exteroception::arondto::ToF& tof,
                             const std::vector<std::string>& split,
                             const ConverterValue& value);


        // std::unique_ptr<ConverterTools> tools;
    };
} // namespace armarx::armem::server::robot_state::exteroception
